///////////////////////////////////////////////////////////////////////////////////////////////////
// ZoneAJAX.js
///////////////////////////////////////////////////////////////////////////////////////////////////
function CZoneAJAX()
{
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.m_XMLHTTP                  = null;
    this.m_cbZoneAJAXResultFunParam = null;
    this.m_cbZoneAJAXResultFun      = null;
    this.m_sLastStatus              = null;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.m_bAbort                   = false;
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.Install                    = CZoneAJAX_Install;
    this.Open                       = CZoneAJAX_Open;
    this.UnInstall                  = CZoneAJAX_UnInstall;
    this.OnReadyStateChange         = CZoneAJAX_OnReadyStateChange;
    this.Abort                      = CZoneAJAX_Abort;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
function CZoneAJAX_Install(cbZoneAJAXResultFun, cbZoneAJAXResultFunParam, sURL, sParam, sMode, bAsync, bNoCache)
{
    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.UnInstall();

    ///////////////////////////////////////////////////////////////////////////////////////////////
    this.m_cbZoneAJAXResultFunParam = cbZoneAJAXResultFunParam;
    this.m_cbZoneAJAXResultFun      = cbZoneAJAXResultFun;
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    var self = this;
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // IE7+, Chrome, Sapari, Firefox, Opera
    if (window.XMLHttpRequest)  this.m_XMLHTTP = new XMLHttpRequest();
    // IE6, IE5
    else                        this.m_XMLHTTP = new ActiveXObject('Microsoft.XMLHTTP');

    ///////////////////////////////////////////////////////////////////////////////////////////////
    if ( this.m_XMLHTTP == null )
        this.m_cbZoneAJAXResultFun(this.m_cbZoneAJAXResultFunParam, "install", false);

    // XMLHttpRequest 상태가 변경될 경우 실행할 이벤트리스너 등록
    this.m_XMLHTTP.onreadystatechange = function(eve)
    {
        self.OnReadyStateChange.apply(self, eve);
    }

    if(typeof (sURL)!="undefined")
        this.Open(sURL, sParam, sMode, bNoCache);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
function CZoneAJAX_UnInstall()
{
    if ( this.m_XMLHTTP != null )
    {
        this.Abort();
        this.m_XMLHTTP = null;
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
function CZoneAJAX_Abort()
{
    if ( this.m_XMLHTTP != null )
    {
        this.m_XMLHTTP.abort();
        this.m_bAbort = true;
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
function CZoneAJAX_Open(sURL, sParam, sMode, bAsync, bNoCache)
{
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if ( this.m_XMLHTTP == null )
        return;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    if ( typeof(sMode)      == "undefined" )     sMode      = "GET";        sMode = sMode.toUpperCase();
    if ( typeof(bAsync)     == "undefined" )     bAsync     = true;
    if ( typeof(bNoCache)   == "undefined" )     bNoCache   = false;

    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    try
    {
        this.m_bAbort                   = false;
        this.m_sLastStatus              = null;
        
        if ( bNoCache ){
            var sNocachekey = "" + (new Date().getTime());
            if ( sURL.indexOf("?") < 0 ){
                sURL = sURL + "?nocachekey=" + sNocachekey;
            }
            else {
                sURL = sURL + "&nocachekey=" + sNocachekey;
            }
        }
        
        if ( sMode == "GET" ){
            if ( sParam != "" ){
                if ( sURL.indexOf("?") < 0 ){
                    sURL = sURL + "?" + sParam;
                }
                else {
                    sURL = sURL + "&" + sParam;
                }
            }

            this.m_XMLHTTP.open('GET', sURL, bAsync);
            this.m_XMLHTTP.send();
        }
        else
        {
            this.m_XMLHTTP.open('POST', sURL, bAsync);
            this.m_XMLHTTP.setRequestHeader("Content-Type","application/x-www-form-urlencoded;charset=UTF-8");
            //this.m_XMLHTTP.setRequestHeader("Cache-Control","no-cache, must-revalidate");
            //this.m_XMLHTTP.setRequestHeader("Pragma","no-cache");
            this.m_XMLHTTP.send(sParam);
        }
    }
    catch(e)
    {
        this.m_cbZoneAJAXResultFun(this.m_cbZoneAJAXResultFunParam, "connect", false);
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
function CZoneAJAX_OnReadyStateChange(eve)
{
    // XMLHttpRequest 상태에 따른 처리
    switch (this.m_XMLHTTP.readyState)
    {
        // 초기화 되지 않은 상태
        case 0 :    break;
        // 서버가 연결된 상태
        case 1 :    break;
        // 요청이 수신된 상태
        case 2 :    break;
        // 처리를 요청한 상태
        case 3 :    break;
        // 요청이 완료되고 응답이 준비된 상태
        case 4 :
            // HTTP 상태에 따른 분기
            switch (this.m_XMLHTTP.status)
            {
                // 성공
                case 200 :
                    if ( ! this.m_bAbort ){
                        this.m_cbZoneAJAXResultFun(this.m_cbZoneAJAXResultFunParam, "recv", this.m_XMLHTTP.status, this.m_XMLHTTP.responseText);
                    }
                    // 로드 성공
                    break;
                default :
                    if ( this.m_sLastStatus !== this.m_XMLHTTP.status ){
                        if ( ! this.m_bAbort )  {
                            this.m_cbZoneAJAXResultFun(this.m_cbZoneAJAXResultFunParam, "recv", this.m_XMLHTTP.status);
                        }
                    }
                    break;
            }
            this.m_sLastStatus              = this.m_XMLHTTP.status;
            break;
        // 기타
        default :
            break;
    }
}
